﻿using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AirFusion
{
	public static class AERegSetting
	{
		public static bool GetIsDisableAudioSetting()
		{
			LogtoFile.TrackEnter();

			try
			{
				bool isX86;
				object oRK = RegistryUtility.GetRegistry(RegistryHive.CurrentUser, Configs.RegAudioPath, Configs.RegAudioDisableKey, RegistryView.Registry64, out isX86);

				if (oRK != null)
				{
					return Convert.ToBoolean(oRK);
				}
			}
			catch
			{
				return false;
			}
			finally
			{
				LogtoFile.TrackLeave();
			}

			return false;
		}

		public static bool GetBoolSettings(string key, string deviceInstanceID, bool valueOfDefault)
		{
			bool result = valueOfDefault;

			try
			{
				bool isX86;
				object oRK = RegistryUtility.GetRegistry(RegistryHive.CurrentUser, Configs.RegUISettingsPath + @"\" + deviceInstanceID, key, RegistryView.Registry64, out isX86);

				if (oRK != null)
				{
					result = Convert.ToBoolean(oRK);
				}
			}
			catch
			{
				return result;
			}

			return result;
		}

		public static bool GetBoolGlobalSettings(string key, bool valueOfDefault)
		{
			bool result = valueOfDefault;

			try
			{
				bool isX86;
				object oRK = RegistryUtility.GetRegistry(RegistryHive.CurrentUser, Configs.RegUISettingsPath, key, RegistryView.Registry64, out isX86);

				if (oRK != null)
				{
					result = Convert.ToBoolean(oRK);
				}
			}
			catch
			{
				return result;
			}

			return result;
		}

		public static string GetStringSettings(string key, string deviceInstanceID)
		{
			string result = string.Empty;

			try
			{
				bool isX86;
				object oRK = RegistryUtility.GetRegistry(RegistryHive.CurrentUser, Configs.RegUISettingsPath + @"\" + deviceInstanceID, key, RegistryView.Registry64, out isX86);

				if (oRK != null)
				{
					result = (string)oRK;
				}
			}
			catch
			{
				return result;
			}

			return result;
		}
	}
}