﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace AirFusion
{
	/// <summary>
	/// Interaction logic for PairingTab.xaml
	/// </summary>
	public partial class PairingTab : UserControl
	{
		#region Events

		public event EventHandler<UserControlEventArgs> UserControlEvent;

		#endregion Events

		#region Constructors & Dispose

		public PairingTab()
		{
			InitializeComponent();
		}

		#endregion Constructors & Dispose

		#region Callbacks

		private void UserControlEventCallback(object sender, UserControlEventArgs e)
		{
			try
			{
				if (e.EventType == UserControlEventType.PageBack)
				{
					LogtoFile.WriteLog("", Configs.DebugLevelValue, "Page Back", "");

					if (e.Data is PageType)
					{
						PageType type = (PageType)e.Data;

						switch (type)
						{
							case PageType.QRCode:
								{
									this.lclShakePage.Visibility = System.Windows.Visibility.Visible;
									this.lclQRCodePage.Visibility = System.Windows.Visibility.Collapsed;

									if (null != this.UserControlEvent)
									{
										this.UserControlEvent(this, new UserControlEventArgs(UserControlEventType.SetDiscoverableValue, null, true));
									}
								}
								break;
						}
					}
				}
				else if (e.EventType == UserControlEventType.ShowQRCode)
				{
					LogtoFile.WriteLog("", Configs.DebugLevelValue, "Show QRCode", "");

					this.lclShakePage.Visibility = System.Windows.Visibility.Collapsed;

					this.lclQRCodePage.QRCodeImage = Configs.ApplicationReference.GetQRCodeImage();
					this.lclQRCodePage.Visibility = System.Windows.Visibility.Visible;

					if (null != this.UserControlEvent)
					{
						this.UserControlEvent(this, new UserControlEventArgs(UserControlEventType.SetDiscoverableValue, null, false));
					}
				}
			}
			catch (Exception ex)
			{
				LogtoFile.WriteLog("", Configs.DebugLevelValue, ex.ToString(), "");
			}
		}

		#endregion Callbacks
	}
}