﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace AirFusion
{
	/// <summary>
	/// Interaction logic for ShakePage.xaml
	/// </summary>
	public partial class ShakePage : UserControl
	{
		#region Events

		public event EventHandler<UserControlEventArgs> UserControlEvent;

		#endregion Events

		#region Properties

		public ICommand ClickHyperlinkQRCode { get; private set; }

		public ICommand ClickHyperlinkStore { get; private set; }

		#endregion Properties

		#region Constructors & Dispose

		public ShakePage()
		{
			// These commands needs to be declared and initialized before initializing UI components because there are UI components uses them with binding.
			//ClickHyperlinkQRCode = new DelegateCommand(this.ShowQRCodePage, null);
			ClickHyperlinkStore = new DelegateCommand(this.LinkToStore, null);

			InitializeComponent();
			this.DataContext = this;
		}

		#endregion Constructors & Dispose

		#region Private Methods

		//private void ShowQRCodePage(object parameter)
		//{
		//	LogtoFile.WriteLog("", Configs.DebugLevelValue, "Call ShowQRCodePage()", "");

		//	if (null != this.UserControlEvent)
		//	{
		//		this.UserControlEvent(this, new UserControlEventArgs(UserControlEventType.ShowQRCode));
		//	}
		//}

		private void btnQRCodePage_Click(object sender, RoutedEventArgs e)
		{
			LogtoFile.WriteLog("", Configs.DebugLevelValue, "Call ShowQRCodePage()", "");

			if (null != this.UserControlEvent)
			{
				this.UserControlEvent(this, new UserControlEventArgs(UserControlEventType.ShowQRCode));
			}
		}

		private void LinkToStore(object parameter)
		{			
			try
			{
				LogtoFile.WriteLog("", Configs.DebugLevelValue, "click LinkToStore()", "");

				Configs.ApplicationReference.LinkToAcerEXTENDPlayStore();

				//System.Diagnostics.Process.Start("https://play.google.com/store/apps/details?id=com.acer.android.airfusion");
			}
			catch (Exception ex)
			{
				LogtoFile.WriteLog("", Configs.DebugLevelValue, "click LinkToStore() exception : " + ex.ToString(), "");
			}
			return;
		}

		#endregion Private Methods

		#region UI Event Handler

		private void UserControl_IsVisibleChanged(object sender, DependencyPropertyChangedEventArgs e)
		{
			if (this.Visibility == System.Windows.Visibility.Visible)
			{
				//Johnon add
				this.txtbShakeDetails.Text = string.Format(Application.Current.TryFindResource("txtPairingHead") as String, Configs.ApplicationReference.GetComputerName());
				//this.runStep2.Text = string.Format(Application.Current.TryFindResource("txtShakeStep2Section1") as String, Configs.ApplicationReference.GetComputerName());
			}
		}

		#endregion UI Event Handler
	}
}