@ECHO off

pushd %~dp0

SET ReleaseFolder=%~1
SET SolutionFolder=%~2
SET ProjectName=%~3
SET ConfigurationName=%~4
SET PlatformName=%~5

ECHO ReleaseFolder=%ReleaseFolder%
ECHO SolutionFolder=%SolutionFolder%
ECHO ProjectName=%ProjectName%
ECHO ConfigurationName=%ConfigurationName%
ECHO PlatformName=%PlatformName%

REM Get current OS architecture
SET ArchitectureName=X86
IF /I "%PlatformName%"=="Any CPU" (
	REM Detect OS architecture
	FOR /f %%a in ('wmic os get osarchitecture^|find /i "-bit"') DO SET "Bits=%%a"
	ECHO Current OS is %Bits%
	IF /I "%Bits%"=="64-bit" SET ArchitectureName=AMD64
) ELSE IF /I "%PlatformName%"=="x64" (
	SET ArchitectureName=AMD64
)

SET NativeDLLFolderWithBuildPlatform=%SolutionFolder%\NativeDLL\[%ConfigurationName%]\%PlatformName%\
IF /I "%PlatformName%"=="x64" SET NativeDLLFolderWithBuildPlatform=%SolutionFolder%\NativeDLL\[%ConfigurationName%]\AMD64\
SET NativeDLLFolderWithCurrentOSArchitecture=%SolutionFolder%\NativeDLL\[%ConfigurationName%]\%ArchitectureName%\
REM　SET NativeDLLFiles="32feetWidcomm.dll" "btwapi.dll" "SoundTriggerforDesktop.dll"
SET NativeDLLFiles="SoundTriggerforDesktop.dll"
SET FinalReleaseFolder=%SolutionFolder%\FinalRelease\%ProjectName%\%ConfigurationName%\%PlatformName%

ECHO NativeDLLFolderWithBuildPlatform=%NativeDLLFolderWithBuildPlatform%
ECHO NativeDLLFolderWithCurrentOSArchitecture=%NativeDLLFolderWithCurrentOSArchitecture%
ECHO NativeDLLFiles=%NativeDLLFiles%
ECHO ArchitectureName=%ArchitectureName%
ECHO FinalReleaseFolder=%FinalReleaseFolder%

:CopyToFinalReleaseFolder
REM Create folders
IF NOT EXIST "%FinalReleaseFolder%" mkdir "%FinalReleaseFolder%"

REM Create exclusion list
ECHO exclusion.txt>exclusion.txt
ECHO .exe.config>>exclusion.txt
IF NOT "%ConfigurationName%"=="Debug" ECHO .pdb>>exclusion.txt
ECHO .vshost>>exclusion.txt
ECHO .log>>exclusion.txt
ECHO .tmp>>exclusion.txt

REM Copy the output folder to final release folder
xcopy "%ReleaseFolder%." "%FinalReleaseFolder%" /S /Y /I /F /EXCLUDE:exclusion.txt

REM Delete exclusion list
DEL /F exclusion.txt

REM Copy native DLLs into final release folder by the build platform
FOR %%s in (%NativeDLLFiles%) DO (
	IF EXIST "%NativeDLLFolderWithBuildPlatform%\%%~s" xcopy "%NativeDLLFolderWithBuildPlatform%\%%~s" "%FinalReleaseFolder%" /S /Y /I /F
)

REM Copy native DLLs into release folder by the current architecture
FOR %%s in (%NativeDLLFiles%) DO (
	IF EXIST "%NativeDLLFolderWithCurrentOSArchitecture%\%%~s" xcopy "%NativeDLLFolderWithCurrentOSArchitecture%\%%~s" "%ReleaseFolder%" /S /Y /I /F
)

popd
EXIT