﻿using AirFusion.Common;
using System;

namespace AirFusion.Manager.DeviceManager
{
	public sealed partial class AFUserDevice
	{
		/// <summary>
		/// Specifies the OS type.
		/// </summary>
		public enum OSTypeValue
		{
			/// <summary>
			/// Signifies the OS type is unknown.
			/// </summary>
			Unknown = -1,

			/// <summary>
			/// Signifies the device is Android.
			/// </summary>
			[ParameterValue("A")]
			Android,

			/// <summary>
			/// Signifies the device is Windows.
			/// </summary>
			[ParameterValue("W")]
			Windows
		}

		/// <summary>
		/// Specifies the pairing status.
		/// </summary>
		public enum PairingStatus
		{
			/// <summary>
			/// Signifies the device is un-paired.
			/// </summary>
			UnPaired,

			/// <summary>
			/// Signifies the device is waiting for pairing response.
			/// </summary>
			PairingPending,

			/// <summary>
			/// Signifies the device is paired.
			/// </summary>
			Paired
		}
	}
}