﻿using AirFusion.Common;
using Newtonsoft.Json;

namespace AirFusion.Manager.FeatureHelper
{
	/// <summary>
	/// Specifies the status of daemon.
	/// </summary>
	public enum DaemonStatus
	{
		/// <summary>
		/// Signifies the daemon is starting.
		/// </summary>
		[ParameterValue("starting")]
		Starting,

		/// <summary>
		/// Signifies the daemon is started.
		/// </summary>
		[ParameterValue("started")]
		Started,

		/// <summary>
		/// Signifies the daemon is paused.
		/// </summary>
		[ParameterValue("paused")]
		Paused,

		/// <summary>
		/// Signifies the daemon is stopping.
		/// </summary>
		[ParameterValue("stopping")]
		Stopping,

		/// <summary>
		/// Signifies the daemon is stopped.
		/// </summary>
		[ParameterValue("stopped")]
		Stopped,

		/// <summary>
		/// Signifies the daemon is terminating.
		/// </summary>
		[ParameterValue("terminating")]
		Terminating,

		/// <summary>
		/// Signifies the daemon is not running.
		/// </summary>
		[ParameterValue("NotRunning")]
		NotRunning,

		/// <summary>
		/// Signifies the status of daemon is unknown.
		/// </summary>
		Unknown
	}
}